#!/bin/sh

Xvfb -screen 0 1280x1024x24 -c nolisten tcp :9 2>/dev/null &
xpid=$!

DISPLAY=:9; export DISPLAY
srcdir=/usr/share/libcairo2-tests; export srcdir

# run the actual test
/usr/lib/libcairo2-tests/cairo-test-suite
e=$?

kill $xpid

# write all subsequent output to stderr so it's easy to see in the logs
exec >&2

# if everything passed, we're happy
if test "$e" = 0; then
  echo "All tests passed! There will be cake"
  exit 0
fi

expected_to_pass=265

# something failed; consult the log to see how badly we failed
summary="`grep '^[0-9][0-9]* Passed,.*Failed.*crashed.*expected.*Skipped$' cairo-test-suite.log`"
echo "TEST SUMMARY: $summary"

passed="${summary%% *}"
if test "$passed" -ge "$expected_to_pass"; then
  echo "$passed (>= $expected_to_pass) passed, that's good enough for now"
  exit 0
fi

echo "Number of test passes has regressed ($passed < $expected_to_pass)"
exit 1
